// Emacs style mode select   -*- C++ -*-
//-----------------------------------------------------------------------------
//
// $Id:$
//
// Copyright (C) 1993-1996 by id Software, Inc.
//
// This source is available for distribution and/or modification
// only under the terms of the DOOM Source Code License as
// published by id Software. All rights reserved.
//
// The source is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// FITNESS FOR A PARTICULAR PURPOSE. See the DOOM Source Code License
// for more details.
//
// $Log:$
//
// DESCRIPTION:
//	Main program, simply calls D_DoomMain high level loop.
//
//-----------------------------------------------------------------------------

static const char
rcsid[] = "$Id: i_main.c,v 1.4 1997/02/03 22:45:10 b1 Exp $";

#include "doomdef.h"
#include "time.h"
#include "m_argv.h"
#include "d_main.h"
#include "d_ddraw.h"

int
funmain( int		argc,  char**	argv )
{
    myargc = argc;
    myargv = argv;

    D_DoomMain ();

    return 0;
}

char ** commandLineToArgv(LPSTR lpCmdLine, int *pArgc);


int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
PSTR szCmdLine, int iCmdShow)
{
    MSG msg;
    int     argc,time=clock();
    char    **argv;
    argv = commandLineToArgv(szCmdLine, &argc);
    mainhwnd=StartWindow(hInstance,iCmdShow);
    while (PeekMessage(&msg, NULL, 0, 0, PM_REMOVE)&&time+1000>clock()) {
        if (msg.message == WM_QUIT) break;
            TranslateMessage(&msg);
            DispatchMessage(&msg);
    }
    return funmain(argc,argv);

}

static char    *fakeName = "Doom";
static char    *argvbuf[64];
static char    cmdLineBuffer[1024];

char ** commandLineToArgv(LPSTR lpCmdLine, int *pArgc)
{
    char    *p, *pEnd;
    int     argc = 0;

    argvbuf[argc++] = fakeName;

    if (lpCmdLine == NULL) {
        *pArgc = argc;
         return argvbuf;
    }

    strcpy(cmdLineBuffer, lpCmdLine);
    p = cmdLineBuffer;
    pEnd = p + strlen(cmdLineBuffer);
    if (pEnd >= &cmdLineBuffer[1022]) pEnd = &cmdLineBuffer[1022];

    fflush(stdout);

    while (1) {
        /* skip over white space */
        fflush(stdout);

        while (*p == ' ') p++;
        if (p >= pEnd) break;

        argvbuf[argc++] = p;
        if (argc >= 32) break;

        /* skip till there's a 0 or a white space */
        while (*p && (*p != ' ')) p++;

        if (*p == ' ') *p++ = 0;
    }

    *pArgc = argc;
    return argvbuf;
}
